// filename - process_metrics.h

#include <stdio.h>
#include <time.h>

#define LOCAL_TIME(x) \
   time_t t = time(NULL); \
   struct tm * locTime = localtime(&t); \
   char x[9]; \
   strftime(x, 9, "%T", locTime); \
   while(0)

clock_t pTicks;

__attribute__((constructor)) void begin ()
{
   LOCAL_TIME(sLocTime);
   printf("begin execution: %s\n", sLocTime);
   pTicks = clock();
}

__attribute__((destructor)) void end ()
{
   pTicks = clock() - pTicks;
   printf("Number of clock ticks: %ld\n", pTicks);
   LOCAL_TIME(sLocTime);
   printf("end execution: %s\n", sLocTime);
}
